image: node:16

stages:
    - lint
    - test
    - publish

cache:
    paths:
        - node_modules/

before_script:
    - npm ci
    - npm run build

.eslint:
    stage: lint
    script:
        - npm run lint

.spellcheck:
    stage: lint
    script:
        - npm run spellcheck

.test_lib:
    stage: test
    script:
        - npm run test
    artifacts:
        when: always
        reports:
            junit:
                - unit-tests.xml

pages:
    stage: publish
    script:
        - npm run build
    artifacts:
        paths:
            - public
    only:
        - main

